#!/usr/bin/wish
menu .mbar -tearoff 0
. configure -menu .mbar
.mbar add cascade -menu .mbar.apple
menu .mbar.apple -tearoff 0
.mbar.apple add command -label "About TreeBank Viewer" -command about
.mbar add cascade -menu .mbar.edit -label Edit
    menu .mbar.edit -tearoff 0
    .mbar.edit add command -label Cut -accel Command-X -command {
        event generate [focus] <<Cut>>
    }
    .mbar.edit add command -label Copy -accel Command-C -command {
        event generate [focus] <<Copy>>
    }
    .mbar.edit add command -label Paste -accel Command-V -command {
        event generate [focus] <<Paste>>
    }
    .mbar.edit add command -label Clear -command {
        event generate [focus] <<Clear>>
    }
.mbar add cascade -menu .mbar.help -label Help
menu .mbar.help -tearoff 0
.mbar.help add command -label "TreeBank Viewer Usage Homepage" -command homepage
if {[catch {package require Tclapplescript}]} {
    tk_messageBox -type ok -message [format "WARNING\n Applescript support not found in the current Tcl/Tk package.\n Tcl/Tk version: %s\n You may update Tcl/Tk from http://tcltkaqua.sourceforge.net/" [info tclversion]]
    proc about {} {
	tk_messageBox -type ok -message "TreeBank Viewer\n Dec 2006 (free version)\n Sandiway Fong\n University of Arizona\n Built on Tcl/Tk and Sicstus Prolog"
    }
    proc homepage {} {
	tk_messageBox -type ok -message "For instructions, please see:\n http://dingo.sbs.arizona.edu/~sandiway/treebankviewer/usage.html"
    }
} else {
    if {[info commands console] != ""} {
	console hide
    }
    proc about {} {
	AppleScript execute {
	    display dialog "TreeBank Viewer\rDec 2006 (free version)\rSandiway Fong\rUniversity of Arizona\r\rBuilt on Tcl/Tk and Sicstus Prolog" with icon file "treebankviewer.icns" buttons { "OK" } default button "OK" with title "About Treebank Viewer"
	}
    }
    proc homepage {} {
	AppleScript execute {
	    open location "http://dingo.sbs.arizona.edu/~sandiway/treebankviewer/usage.html"
	}
    }
}
set vsep 15
set WEIGHT "normal"
set SLANT "roman"
set minbr 50
set hsep 5
set node1 0
set node2 0
set drop 20
set arrows ""
set arrowsids ""
set trees ""
set max 0
image create photo logo -data "R0lGODlhuQAYAMQQAICAgEBAQPDw8ODg4NDQ0GBgYKCgoDAwMBAQECAgIFBQULCw
sJCQkHBwcMDAwAAAAP///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAACH5BAEAABAALAAAAAC5ABgAAAX/ICSOZGmeaKqubOu+cCzP
dG3feK7vfO//wKBwSCwaj8ikcslsOp/QqLRGSFWn2Gws8Oh6v0nB4etNAJwCxcNg
KjzOWlQDQHcH6ADFiODo+68jfoJ9VwKDfmwjXHh4CQ8MJYZ9JgN9AyR8lyKVDiOS
gCQDDwUmAQiefQIjnIcLEJKqInyAkpuHfa62hygObye9ZKMkAMFdnSJcxSRcJgIP
ASYHCQcnXaC9Jb6yCAGxJmqastrI0CTFzyIFeiML4xAHiRDn5SLFB96B7vnHIg0P
4cROhAtAb9WyByYICCPhAIHCcCMeSPOGzRwcBvpK9GpAwg1EgtnghBLRK5yCBAlW
/z3wlhGiu3bx8olk+IAfhF78AqoAufMZwZ8SQUFQcCYAqWwODtwjidBiGgQ2UZiK
5eyoooLyZpowI8KZwit5LK7Ql7GXVqYMBLnxRmxQLkUHBC0QyuXnTwQI3kIQdakk
UjFHK0Y8mQABPhQGHoloW4JnxAKCIJFgkBKCAWoKjiaIOSqyic5+MOplevZmsM3D
gmlN9iUqs0gHDI9oYNUoUggEEHAUXM+XYxUoRUwrhVUZCWeuDkBacCp3tmCfyej+
ldH0sYYQIejc07iggOyvSzB+hUA6vpriDPCWx5G8ZBWJDcQnHhJTGwWiYm2mXZ97
fwF58VIdTiMUgNV2UmFVSr5TJahxxWWDcBURP4khmBU7DwjVDAIHBFBZd/1ZMco6
2p00WnViiWCAbCaYRR0/AL6nXU23wHULIIswAkBdI6BGwoos2YQRg/XM1EACh5lA
THW/yQPZIDG9s4ZKp2TzpCCczRQAiT8uVMJ8IwDgUIHnwCHGOceceVoBsWCUnSjt
iRKTAI6EI4pVe42SZJfowbbUJucQCYEbtChVgijnqIRnL1EGkZ1AcQzxqA2TRmrp
pZhmqummnHbq6aegphACADs="

image create photo logo2 -data "R0lGODlhMgIYANUgAMDAwN/GwZ5TRL+Ng/fy8OfV0e/j4c+qord/c6ZiVICAgK9wZEBAQJZFNY43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"

frame .f

frame .f.f
label .f.f.logo -image logo
bind .f.f.logo <Enter> ".f.f.logo configure -image logo2"
bind .f.f.logo <Leave> ".f.f.logo configure -image logo"
pack .f.f.logo -anchor nw

set f1 "No file set"
set f2 "No file set"

frame .f.f.f
button .f.f.f.b1 -text "Sentence File" -command {set f1 [tk_getOpenFile -title "Sentence File"]}
entry .f.f.f.f1 -width 32 -textvariable f1
button .f.f.f.b2 -text "Prolog Tree File" -command {set f2 [tk_getOpenFile -title "Prolog Tree File" -filetypes {{{Prolog Tree Files} {.pl}}}]}
entry .f.f.f.f2 -width 32 -textvariable f2
button .f.f.f.b3 -text "Load" -command {textfile $f1 $f2}
grid .f.f.f.b1 .f.f.f.f1 .f.f.f.b2 .f.f.f.f2 .f.f.f.b3
pack .f.f.f

set cnt 0
set selt "(none)"
set ff 1
frame .f.f.f3
label .f.f.f3.lb1 -text "Sentence Count:"
label .f.f.f3.lb2 -textvariable cnt -foreground blue
label .f.f.f3.lb6 -text "Displayed Tree (Sentence):" 
entry .f.f.f3.lb7 -width 6 -textvariable selt -foreground blue
bind .f.f.f3.lb7 <KeyPress-Return> goto_tree
label .f.f.f3.lb11 -text "Info:"
label .f.f.f3.lb10 -text "" -width 20
label .f.f.f3.lb8 -text "Zoom: (x1)" 
scale .f.f.f3.s -from 1 -to 4 -resolution 0.5 -variable ff -command redrawtree -orient horizontal -length 200 -showvalue false
label .f.f.f3.lb9 -text "(x4)" 
grid .f.f.f3.lb1 .f.f.f3.lb2 .f.f.f3.lb6 .f.f.f3.lb7 .f.f.f3.lb11 .f.f.f3.lb10 .f.f.f3.lb8 .f.f.f3.s .f.f.f3.lb9
pack .f.f.f3

panedwindow .f.uf

frame .f.uf.f3
frame .f.uf.f3.cf
font create sentencefont -family system -size 12
text .f.uf.f3.cf.c -width 40 -font sentencefont -undo false -wrap none -xscrollcommand ".f.uf.f3.x set" -yscrollcommand ".f.uf.f3.cf.y set"
scrollbar .f.uf.f3.cf.y -command ".f.uf.f3.cf.c yview" -orient v -bd 1 -relief sunken
pack .f.uf.f3.cf.c .f.uf.f3.cf.y -side left
pack .f.uf.f3.cf.y -side right
pack .f.uf.f3.cf.c -fill both -expand 1 -anchor ne
pack .f.uf.f3.cf.y -fill y -anchor nw
scrollbar .f.uf.f3.x -command ".f.uf.f3.cf.c xview" -orient h -bd 1 -relief sunken
pack .f.uf.f3.cf .f.uf.f3.x -side top -anchor ne
pack .f.uf.f3.cf -fill both -expand 1
pack .f.uf.f3.x -fill x
pack .f.uf.f3 -fill both -expand 1

frame .f.uf.f2
frame .f.uf.f2.cf
canvas .f.uf.f2.cf.c -xscrollcommand ".f.uf.f2.x set" -yscrollcommand ".f.uf.f2.cf.y set" -scrollregion {0 0 10000 2000}
scrollbar .f.uf.f2.cf.y -command ".f.uf.f2.cf.c yview" -orient v -bd 1 -relief sunken
pack .f.uf.f2.cf.c .f.uf.f2.cf.y -side left
pack .f.uf.f2.cf.y -side right
pack .f.uf.f2.cf.c -fill both -expand 1 -anchor ne
pack .f.uf.f2.cf.y -fill y -anchor nw
scrollbar .f.uf.f2.x -command ".f.uf.f2.cf.c xview" -orient h -bd 1 -relief sunken
pack .f.uf.f2.cf .f.uf.f2.x -side top -anchor ne
pack .f.uf.f2.cf -fill both -expand 1
pack .f.uf.f2.x -fill x
pack .f.uf.f2 -fill both -expand 1

.f.uf add .f.uf.f3 .f.uf.f2

pack .f.f .f.uf -side top -anchor nw

pack .f.uf -expand 1 -fill both

pack .f -expand 1 -fill both

font create treefont -family system -size 14
proc mktext {t} {
    set id [.f.uf.f2.cf.c create text 0 0 -anchor n -text $t -font treefont]
    return $id
}

proc mktext2 {t col} {
    set id [.f.uf.f2.cf.c create text 0 0 -anchor n -text $t -font treefont]
    .f.uf.f2.cf.c bind $id <Enter> "showmst $id $col"
    .f.uf.f2.cf.c bind $id <Leave> "hidemst $id"
    return $id
}

proc showmst {id col} {
    global mstxta
    .f.uf.f2.cf.c itemconfigure $id -fill $col
    .f.f.f3.lb10 configure -text $mstxta($col) -foreground $col
}

proc hidemst {id} {
    .f.uf.f2.cf.c itemconfigure $id -fill black
    .f.f.f3.lb10 configure -text ""
}

proc clearcanvas {} {
    .f.uf.f2.cf.c delete all
}

font create largefont -family system -weight bold -size 28
proc notree {} {
    clearcanvas
    .f.uf.f2.cf.c create text 60 5 -anchor n -text "No Tree" -font largefont -fill grey
}

proc size {id} {
    set box [.f.uf.f2.cf.c bbox $id]
    set width [expr {[lindex $box 2] - [lindex $box 0]}] 
    return $width
}

proc treewindow {w h} {
    global vsep
    .f.uf.f2.cf.c configure -width $w -height [expr $h*$vsep]
}

proc movenode {id x row} {
    global vsep
    .f.uf.f2.cf.c move $id $x [expr $row*$vsep]
}

proc relocate {id dx dy} {
    .f.uf.f2.cf.c move $id $dx $dy
}

proc branch {row c l r} {
    global vsep ff
    set v1 [expr $row*$vsep]
    set v2 [expr $v1+$vsep]
    .f.uf.f2.cf.c create line $l $v2 $c $v1 $r $v2 -width [expr int($ff)]
}

proc nbranch {row c bf args} {
    global vsep ff
    set v1 [expr $row*$vsep]
    set v2 [expr $v1+$vsep]
    set ls ""
    foreach br $args {
	if {$ls == ""} {
	    lappend ls $br $v2
	} else {
	    lappend ls $c $v1 $br $v2
	}
    }
    .f.uf.f2.cf.c create line $ls -width [expr int($ff)]
}

proc nobranch {row c} {
    global vsep ff
    set v1 [expr $row*$vsep]
    set v2 [expr $v1+$vsep]
    .f.uf.f2.cf.c create line $c $v2 $c $v1 -width [expr int($ff)]
}

proc setvsep {v} {
    global vsep
    set vsep $v
}

proc sethsep {w} {
    global hsep
    set hsep $w
}

proc gethsep {} {
    global hsep
    return $hsep
}

proc setminbranching {w} {
    global minbr
    set minbr $w
}

proc getbranching {} {
    global minbr
    return $minbr
}

proc draw {} {
    .f.uf.f2.cf.c delete all
    prolog [format "prTree(%s)" [.f.lf.e get]]
}

proc textfile {f1 f2} {
    global trees max cnt selt last mstxta
    if {($f1 == "No file set") || ($f2 == "No file set")} {
	tk_messageBox -type ok -icon error -message "Select Sentence and Prolog Tree files first"
    } else {
    if {[file exists $f1]} {
	set id1 [open $f1]
#	fconfigure $id1 -encoding gb12345
	set data [read $id1]
	close $id1

	set lines [split $data "\n"]

	if {[file exists $f2]} {
	    set id2 [open $f2]
	    set data [read $id2]
	    close $id2

	    set trees [split $data "\n"]

	    .f.uf.f3.cf.c delete 1.0 end
	    bind .f.uf.f3.cf.c <KeyPress-Down> do_prolog_down
	    bind .f.uf.f3.cf.c <KeyPress-Up> do_prolog_up

	    set last -1
	    set cnt 0
	    set selt "(none)"
	    clearcanvas

	    set i 0
	    foreach line $lines {
		.f.uf.f3.cf.c insert end [format "%s\n" $line]  $i
		.f.uf.f3.cf.c tag bind $i <ButtonPress> [list do_prolog $i]
		incr i
	    }
	    set max [expr $i-1]
	    set cnt $i

	    set auxfile "$f2.aux"
	    if {[file exists $auxfile]} {
		set id3 [open $auxfile]
		set data [read $id3]
		close $id3

		array set mstxta $data
	    }
	} else {
	    tk_messageBox -type ok -message [format "File %s does not exist!" $f2]
	}
	
    } else {
	tk_messageBox -type ok -message [format "File %s does not exist!" $f1]
    }
    }
}

proc redrawtree {f} {
    global last trees vsep
    set vsep [expr 15*$f]
    font configure treefont -size [expr int(14*$f)]
    prolog [format "setbranchsep(%f)" $f]
    if {$last >= 0} {
	prolog [lindex $trees $last]
    }
}

set last -1
proc do_prolog {i} {
    global last trees selt
    if {$last >= 0} {
	.f.uf.f3.cf.c tag configure $last -background white
    }

    if {[.f.uf.f3.cf.c tag ranges $i] == ""} {
	notfound_msg $i
    } else {
	.f.uf.f3.cf.c tag configure $i -background lightblue
	set selt [expr $i+1]
	set last $i
	prolog [lindex $trees $i]
    }
}

proc notfound_msg {i} {
    tk_messageBox -type ok -icon error -message [format "Treebankviewer\nSentence number %s not found!" [expr $i+1]]
}

proc do_prolog_down {} {
    global last max trees selt
    if {$last >= 0 && $last < $max} {
	.f.uf.f3.cf.c tag configure $last -background white
	incr last
	.f.uf.f3.cf.c tag configure $last -background lightblue
	set selt [expr $last+1]
	prolog [lindex $trees $last]
    }
}

proc do_prolog_up {} {
    global last trees selt
    if {$last > 0} {
	.f.uf.f3.cf.c tag configure $last -background white
	incr last -1
	.f.uf.f3.cf.c tag configure $last -background lightblue
	set selt [expr $last+1]
	prolog [lindex $trees $last]
    }
}

proc goto_tree {} {
    global max last trees selt
    if {$selt != "(none)"} {
	if {$selt > 0 && $selt <= $max} {
	    .f.uf.f3.cf.c tag configure $last -background white
	    set last [expr $selt-1]
	    .f.uf.f3.cf.c tag configure $last -background lightblue
	    .f.uf.f3.cf.c mark set insert $last.0
	    .f.uf.f3.cf.c see insert
	    prolog [lindex $trees $last]
	} else {
	    tk_messageBox -type ok -message [format "Sentence number %s is out of range!" $selt]
	}
    }
}

proc goto_tree2 {i} {
    global max last trees selt
    if {$i > 0 && $i <= $max} {
	set selt $i
	.f.uf.f3.cf.c tag configure $last -background white
	set last [expr $selt-1]
	.f.uf.f3.cf.c tag configure $last -background lightblue
	.f.uf.f3.cf.c mark set insert $last.0
	.f.uf.f3.cf.c see insert
	prolog [lindex $trees $last]
    } 
}

proc accept {sock ip port} {
    fconfigure $sock -blocking 0 -buffering line
    fileevent $sock readable [list action $sock]
}

proc action {sock} {
    if {[catch {gets $sock data}] || [eof $sock]} {
	catch {close $sock}
	return
    }

    do_prolog $data
    .f.uf.f3.cf.c see $data.0
}

set port 2001
while {[catch {socket -server accept $port}] != 0} {
    incr port
}
